package com.gingersoft.gsa.cloud.meal.mvp.model;

import android.app.Application;

import com.gingersoft.gsa.cloud.base.bean.BaseRespose;
import com.gingersoft.gsa.cloud.base.bean.FoodBean;
import com.gingersoft.gsa.cloud.database.bean.Food;
import com.gingersoft.gsa.cloud.database.utils.FoodDaoUtils;
import com.gingersoft.gsa.cloud.meal.mvp.model.bean.request.SendOrderRequest;
import com.gingersoft.gsa.cloud.meal.mvp.model.service.MealService;
import com.google.gson.Gson;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;

import com.jess.arms.di.scope.ActivityScope;

import javax.inject.Inject;

import com.gingersoft.gsa.cloud.meal.mvp.contract.MealStandContract;

import java.util.List;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 12/27/2019 19:17
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@ActivityScope
public class MealStandModel extends BaseModel implements MealStandContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public MealStandModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }

    @Override
    public Observable<BaseRespose> loadOrder(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(MealService.class)
                .loadOrder(requestBody);
    }

    @Override
    public Observable<BaseRespose> sendOrder(List<SendOrderRequest> foods) {
        return mRepositoryManager.obtainRetrofitService(MealService.class)
                .sendOrder(foods);
    }

    @Override
    public Observable<BaseRespose> addFood(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(MealService.class)
                .addFood(requestBody);
    }

    @Override
    public Observable<BaseRespose> deleteFood(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(MealService.class)
                .deleteFood(requestBody);
    }

    @Override
    public List<Food> queryDB_FoodGroupList() {
        FoodDaoUtils foodDaoUtils = new FoodDaoUtils(mApplication);
        return foodDaoUtils.queryFoodGroupByQueryBuilder();
    }

    @Override
    public List<Food> queryDB_FoodList(long parentId) {
        FoodDaoUtils foodDaoUtils = new FoodDaoUtils(mApplication);
        return foodDaoUtils.queryFoodByQueryBuilder(parentId);
    }
}